; Script generated by the HM NIS Edit Script Wizard.

SetCompressor bzip2

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Botik::Balance"
!define PRODUCT_EXE_NAME "BotikBalance"
!define PRODUCT_VERSION "0.7.1.126-pre"
!define PRODUCT_PUBLISHER "Alexander V. Melnikoff"
!define PRODUCT_WEB_SITE "http://www.botik.ru/~botik-key-pro/botik-balance/"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\bblnc32.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_EXE_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

XPStyle on
ReserveFile "${NSISDIR}\Plugins\InstallOptions.dll"
ReserveFile "ioWarningPage.ini"

Var TMPVAR

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\orange-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\orange-uninstall.ico"
!define MUI_WELCOMEFINISHPAGE_BITMAP "graphics\orange-wizard.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP "graphics\orange-wizard-uninstall.bmp"
!define MUI_HEADERIMAGE # Turn on header image bitmap
!define MUI_HEADERIMAGE_BITMAP "graphics\orange-header.bmp"
!define MUI_UNHEADERIMAGE_BITMAP "graphics\orange-header-uninstall.bmp"
!define MUI_WELCOMEPAGE_TITLE_3LINES
!define MUI_FINISHPAGE_TITLE_3LINES

; Language Selection Dialog Settings
!define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"

; Welcome page
!insertmacro MUI_PAGE_WELCOME

; Warn user about security
;Page custom WarningPage

; License page
;LicenseLangString license ${LANG_ENGLISH} "..\license_eng.txt"
!define MUI_LICENSEPAGE_RADIOBUTTONS
!insertmacro MUI_PAGE_LICENSE "..\license_eng.txt"

; Directory page
!insertmacro MUI_PAGE_DIRECTORY

; Start menu page
Var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "${PRODUCT_EXE_NAME}"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP

; Instfiles page
!insertmacro MUI_PAGE_INSTFILES

; Warn user about security
Page custom WarningPage

; Finish page
!define MUI_FINISHPAGE_RUN
!define MUI_FINISHPAGE_RUN_FUNCTION onFinishRun
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!define MUI_WELCOMEPAGE_TITLE_3LINES
!define MUI_FINISHPAGE_TITLE_3LINES

!insertmacro MUI_UNPAGE_WELCOME
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

; Uninstall finish page
!insertmacro MUI_UNPAGE_FINISH

; Language files
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "Russian"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "${PRODUCT_EXE_NAME}Setup_${PRODUCT_VERSION}.exe"
InstallDir "$PROGRAMFILES\${PRODUCT_EXE_NAME}"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show
LicenseBkColor FFFFFF
XPStyle on

; Version info tab

Function onFinishRun
  ClearErrors

  Exec "$INSTDIR\bblnc32.exe"

  IfErrors ErrorHandler

ErrorHandler:
; Do nothing...
FunctionEnd

Function .onInit
  !insertmacro MUI_LANGDLL_DISPLAY
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "ioWarningPage.ini"
FunctionEnd

Section "MainSection" SEC01
  SetShellVarContext all
  SetOutPath "$INSTDIR"
  SetOverwrite on
  
  File "..\bin\bblnc32.exe"
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut  "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME}.lnk" "$INSTDIR\bblnc32.exe"
  CreateShortCut  "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME} Help.lnk" "$INSTDIR\help.chm"
  CreateShortCut  "$DESKTOP\${PRODUCT_EXE_NAME}.lnk" "$INSTDIR\bblnc32.exe"
  File "..\bin\bbobj32.dll"
  File "..\license_eng.txt"
  File "..\license_rus.txt"
  File "..\credits_eng.txt"
  File "..\credits_rus.txt"
  File "..\changelog_eng.txt"
  File "..\changelog_rus.txt"
  File "..\bin\bblnc32.exe.manifest"
  File "..\bin\help.chm"
  File "..\bin\install.bat"
  File "..\bin\uninstall.bat"
  File "..\bin\message.wav"
SectionEnd

Section -AdditionalIcons
  SetShellVarContext all
  
  WriteIniStr "$INSTDIR\${PRODUCT_EXE_NAME} Homepage.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME} Homepage.lnk" "$INSTDIR\${PRODUCT_EXE_NAME} Homepage.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\License (English).lnk" "$INSTDIR\license_eng.txt"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\License (Russian).lnk" "$INSTDIR\license_rus.txt"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\bblnc32.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\bblnc32.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}" "$ICONS_GROUP"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
  
  ; Register bbobj32.dll
  ExecWait 'regsvr32.exe /s "$INSTDIR\bbobj32.dll"' $TMPVAR
  DetailPrint "Component registration code (0 is success): $TMPVAR"
SectionEnd


;Function un.onUninstSuccess
;  HideWindow
;  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
;FunctionEnd

Function un.onInit
!insertmacro MUI_UNGETLANGUAGE
;  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
;  Abort
FunctionEnd

Section Uninstall
  SetShellVarContext all
  
  ReadRegStr $ICONS_GROUP ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}"
  
  ; Unregister bbobj32.dll
  ExecWait 'regsvr32.exe /s /u "$INSTDIR\bbobj32.dll"' $TMPVAR
  DetailPrint "Component unregistration code (0 is success): $TMPVAR"
  
  Delete "$INSTDIR\${PRODUCT_EXE_NAME} Homepage.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\changelog_eng.txt"
  Delete "$INSTDIR\changelog_rus.txt"
  Delete "$INSTDIR\credits_eng.txt"
  Delete "$INSTDIR\credits_rus.txt"
  Delete "$INSTDIR\license_eng.txt"
  Delete "$INSTDIR\license_rus.txt"
  Delete "$INSTDIR\bblnc32.exe.manifest"
  Delete "$INSTDIR\help.chm"
  Delete "$INSTDIR\install.bat"
  Delete "$INSTDIR\uninstall.bat"
  Delete "$INSTDIR\message.wav"
  Delete /REBOOTOK "$INSTDIR\bbobj32.dll"
  Delete /REBOOTOK "$INSTDIR\bblnc32.exe"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME} Homepage.lnk"
  Delete "$DESKTOP\${PRODUCT_EXE_NAME}.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME}.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\License (English).lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\License (Russian).lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\${PRODUCT_EXE_NAME} Help.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd

;#######################################################################
;# Custom pages
;#######################################################################

Var HWND
Var DLGITEM
Var FONT

LangString TEXT_IO_WARNPAGE_TITLE ${LANG_ENGLISH} "Security Warning"
LangString TEXT_IO_WARNPAGE_TITLE ${LANG_RUSSIAN} "  "

LangString TEXT_IO_WARNPAGE_SUBTITLE ${LANG_ENGLISH} "Please, follow the instructions below to secure your account"
LangString TEXT_IO_WARNPAGE_SUBTITLE ${LANG_RUSSIAN} ",         "

Function WarningPage
  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_WARNPAGE_TITLE)" "$(TEXT_IO_WARNPAGE_SUBTITLE)"
  !insertmacro MUI_INSTALLOPTIONS_INITDIALOG "ioWarningPage.ini"

  Pop $HWND ;HWND of dialog

  GetDlgItem $DLGITEM $HWND 1200 ;1200 + Field number - 1
  CreateFont $FONT "Tahoma" 10 700
  SendMessage $DLGITEM ${WM_SETFONT} $FONT 0

  !insertmacro MUI_INSTALLOPTIONS_SHOW
FunctionEnd
