/*  BotikBalance - User's account balance informer for Botik Network 
 *                 for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2005 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Sorry for the long lines in the sources, I have wide screen... ;-)
 */

/* This object is using in the script engine to present BotikBalance.
 */

#ifndef __BOTIKBALANCEOBJ_H__
#define __BOTIKBALANCEOBJ_H__

#include <scripthostobj_h.h>

class CBotikBalanceObj : public IBotikBalanceObj //,IProvideClassInfo
{
public:
	CBotikBalanceObj(void);
	~CBotikBalanceObj(void);

public:
	// IUnknown
	virtual HRESULT __stdcall QueryInterface(const IID& riid_, void** ppv_);
	virtual ULONG	__stdcall AddRef(void);
	virtual ULONG	__stdcall Release(void);

	// IDispatch
	virtual HRESULT __stdcall GetTypeInfoCount(UINT* pCountTypeInfo_);
	virtual HRESULT __stdcall GetTypeInfo(UINT iTypeInfo_, LCID, ITypeInfo** ppITypeInfo_);
	virtual HRESULT __stdcall GetIDsOfNames(const IID& riid_, OLECHAR** arrayNames_, UINT cNames_, 
											LCID, DISPID* arrayDispIDs_);
	virtual HRESULT __stdcall Invoke(DISPID dispidMember_, const IID& riid_, LCID, WORD wFlags_, 
									 DISPPARAMS* pDispParams_, VARIANT* pvarRes_, EXCEPINFO* pEI_, UINT* pArgErr_);
/*
	// IProvideClassInfo
	virtual HRESULT __stdcall GetClassInfo(ITypeInfo **ppTI_);
*/
	// IBotikBalance
	virtual HRESULT __stdcall RequestPage(LONG lMethod_, BSTR bsHost_, LONG lPort_, BSTR bsPath_, 
										  BSTR bsBody_, BSTR bsHeaders_, BOOL fUseSSL_, BSTR* pbsPage_);
	virtual HRESULT __stdcall DbgPrint(BSTR bsStr_);
	virtual HRESULT __stdcall SetData(BSTR bsName_, BSTR bsVal_);

	virtual HRESULT __stdcall get_AccountName(BSTR* pbsRet_);
	virtual HRESULT __stdcall get_User(BSTR* pbsRet_);
	virtual HRESULT __stdcall get_Password(BSTR* pbsRet_);
	virtual HRESULT __stdcall get_LastOperationCode(LONG* plRet_);

	virtual HRESULT __stdcall put_onUpdate(IDispatch* pOnUpdateSink_);
	virtual HRESULT __stdcall put_onConnect(IDispatch* pOnConnectSink_);
	virtual HRESULT __stdcall put_onDisconnect(IDispatch* pOnDisconnectSink_);

	// CBotikBalanceObj
	static CBotikBalanceObj* CreateObject();
	BOOL Init(ITypeLib* pITypeLib_);
	LONG Fire_OnUpdate(VOID);
	LONG Fire_OnConnect(VOID);
	LONG Fire_OnDisconnect(VOID);

private:
	LONG		m_cRef;
	ITypeInfo*	m_pITypeInfo;
	IDispatch*	m_pOnUpdateSink;
	IDispatch*	m_pOnConnectSink;
	IDispatch*	m_pOnDisconnectSink;

	LONG		m_lLastOpCode;
};

#endif // __BOTIKBALANCEOBJ_H__
